<template>
    <div v-cloak>
    <!-- Content Header (Page header) -->
        <div class="content-header pt-4">
            <div class="container-fluid">
                <div class="row mb-2">
                <div class="col-sm-6">
                    <h1 class="m-0 text-dark">Dashboard

                    </h1>
                </div><!-- /.col -->
                </div><!-- /.row -->
            </div><!-- /.container-fluid -->
        </div>
        <!-- /.content-header -->

        <!-- Main content -->
        <section class="content">
        <div class="container-fluid">
            <!-- Small boxes (Stat box) -->
            <div class="row" v-if="dataLoaded">
                <div class="col-lg-4 col-6">
                    <!-- small box -->
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header" style="background-color:rgb(210,181,0)">
                        <div class="widget-user-image">
                         <span class="icon" ><i class="las la-book text-white"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username text-white">Projets</h3>
                        <h5 class="widget-user-desc text-white">Aperçu général</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Total <span class="float-right ">{{entities.nombre_projet}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    En cours<span class="float-right ">{{entities.projet_en_cours}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Terminé <span class="float-right ">{{entities.projet_termine}}</span>
                                    </a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/projets" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <!-- ./col -->
                <div class="col-lg-4 col-6">
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header" style="background-color:#017890">
                        <div class="widget-user-image">
                            <span class="icon" ><i class="las la-industry text-white"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username text-white" style="">Entreprises</h3>
                        <h5 class="widget-user-desc text-white">Aperçu général</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Total <span class="float-right ">{{entities.nombre_entreprise}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Secteurs d'activités <span class="float-right ">{{entities.effectif_moyen}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Pays <span class="float-right ">{{entities.effect}}</span>
                                    </a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/entreprises" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <div class="col-lg-4 col-6">
                    <!-- small box -->
                <div class="card card-widget widget-user-2">
                    <!-- Add the bg color to the header using any of the bg-* classes -->
                    <div class="widget-user-header" style="background-color:#901259">
                        <div class="widget-user-image">
                            <span class="icon" ><i class="las la-user-circle text-white"></i></span>
                        </div>
                        <!-- /.widget-user-image -->
                        <h3 class="widget-user-username text-white">Membres</h3>
                        <h5 class="widget-user-desc text-white">Aperçu général</h5>
                    </div>
                    <div class="card-footer p-0">
                        <ul class="nav flex-column">
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Total<span class="float-right ">{{entities.nombre_membre}}</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Nationalités representées<span class="float-right ">0 %</span>
                                    </a>
                            </li>
                            <li class="nav-item">
                                <a href="javascript:void(0)" class="nav-link">
                                    Pays le plus représenté <span class="float-right ">0</span>
                                    </a>
                            </li>
                            <li class="nav-item bg-white">
                                <router-link to="/trombinoscope" class=" p-2 pl-3 small-box-footer ">En savoir plus <i class="fas fa-arrow-circle-right"></i></router-link>
                            </li>
                        </ul>
                    </div>
                </div>
                </div>
                <!-- ./col -->
            </div>
            <!-- /.row -->

        </div><!-- /.container-fluid -->
        </section>
        <!-- /.content -->

        <div class="row">
            <div class="small col-sm-4">
                <line-chart
                    v-if="loaded"
                    :chart-data="nbprojet"
                    :chart-labels="mois"

                    />
            </div>
            <div class="small col-sm-4">
                <doughnut-chart
                    v-if="loaded"
                    :chart-data="secteur"
                    :chart-labels="labels"
                  />
            </div>
            <div class="small col-sm-4">
                <bar-chart
                    v-if="loaded"
                    :chart-data="nbpromotion"
                    :chart-labels="promotion"
                />
                <!-- <doughnut-chart :chart-data="test"></doughnut-chart> -->
            </div>
        </div>


    </div>

</template>

<script>
    import Master from "./Master.vue";
    import BarChart from './BarChart.vue'
    import LineChart from './LineChart.vue'
    import DoughnutChart from './DoughnutChart.vue'


  export default {
    components: {
      BarChart,
      LineChart,
      DoughnutChart
    },
    props: {},
    mixins: [Master],
    data () {
      return {
        loaded: false,
        info:"",
        entities:{
            nombre_projet:"",
            projet_en_cours:"",
            projet_termine:"",
            nombre_entreprise:"",
            effectif_moyen:"",
            effectif_total:"",
        },
        dataLoaded:{},
        secteur: [],
        nbpromotion:[],
        nbprojet:[],

        // labels: [],
        showError: false,
        projet:null,

      }
    },
     created()
    {
        this.pageInit = false
    },
    mounted () {
         this.pageInit = true
                    // this.fillData()
              this.$forceUpdate()
        this.requestData()
        // this.pageInit = false
    },
    methods: {
      resetState () {
        this.loaded = false
        this.showError = false
      },
      requestData () {
        this.resetState()
        var url = "/api/dashboard/"
        axios.get(url,{ params : this.params })
          .then(response => {
              this.entities = response.data
                       this.waiting.entities = true
                       this.dataLoaded = true
                       //Mappage de donnée pour les secteur d'activité les plus représenté
                        this.secteur = _.map(response.data.secteur,(e)=> {
                                    return e.NbEntreprise
                                })
                        this.labels = _.map(response.data.secteur,(e)=> {
                                    return e.libelle
                                })

                        //Mappage de donnée pour les promotions
                        this.nbpromotion = _.map(response.data.statPromotion,(e)=> {
                                    return e.Npromotion
                                })
                        this.promotion = _.map(response.data.statPromotion,(e)=> {
                                    return e.promotion
                                })

                        //Mappage de donnée pour nombre de projet realisé aucours de l'année
                        this.nbprojet = _.map(response.data.statStatutProjet,(e)=> {
                                    return e.data
                                })
                        this.mois = _.map(response.data.statStatutProjet,(e)=> {

                                    return e.month+'/'+e.year
                                })
                        // this.mois = ['jan','fev','Mars','Avril','Mai','Juin','juil','Aout','Sept','Optob','Nov','Dec']

                this.loaded = true
          })
          .catch(err => {
            this.errorMessage = err.response.data.error
            this.showError = true
          })
      },
      waiting:
            {
            entities:false,
            },
    }
  }
</script>
<style scoped>
   .small-box{
       min-height: 111px;
   }
     .small {
    max-width: 100%;
  }
  .widget-user-header
  {
      color:black;
  }
  .widget-user-image .icon
  {
    float: left;
    height: auto;
    font-size: 80px;
  }
    .widget-user-2 .widget-user-header
  {
     color :black !important;
  }
    .widget-user-2 li.nav-item  a
  {
     cursor:default !important;
     color :black;
  }
      .widget-user-2 li.nav-item:last-child  a
  {
     cursor: pointer !important;
  }
  .widget-user-2 li.nav-item  span.float-right
  {
      color :black;
  }

  .bloc-recent-history-date-text
  {
    color: #6c757d;
    font-size: 0.8rem;
  }
  .small {
    max-width: 400px;
    margin:  100px auto;
  }
</style>

